Loading...
Searching...
No Matches
TimeBlockEncoder Class Referenceabstract

`#include <timeblockencoder.h>`

## Public Types

typedef TimeBlockBuffer< std::complex< float > > | FBuffer
typedef TimeBlockBuffer< std::complex< float > >::DataRow | FBufferRow
typedef TimeBlockBuffer< std::complex< double > > | DBuffer
typedef TimeBlockBuffer< std::complex< double > >::DataRow | DBufferRow
typedef unsigned | symbol_t

## Public Member Functions

virtual | ~TimeBlockEncoder ()
virtual void | EncodeWithDithering (const dyscostman::StochasticEncoder< float > &gausEncoder, FBuffer &buffer, float *metaBuffer, symbol_t *symbolBuffer, size_t antennaCount, std::mt19937 &rnd)=0
virtual void | EncodeWithoutDithering (const dyscostman::StochasticEncoder< float > &gausEncoder, FBuffer &buffer, float *metaBuffer, symbol_t *symbolBuffer, size_t antennaCount)=0
virtual void | InitializeDecode (const float *metaBuffer, size_t nRow, size_t nAntennae)=0
virtual void | Decode (const dyscostman::StochasticEncoder< float > &gausEncoder, FBuffer &buffer, const symbol_t *symbolBuffer, size_t blockRow, size_t antenna1, size_t antenna2)=0
virtual size_t | SymbolCount (size_t nRow, size_t nPol, size_t nChannels) const =0
virtual size_t | SymbolCount (size_t nRow) const =0
virtual size_t | SymbolsPerRow () const =0
virtual size_t | MetaDataCount (size_t nRow, size_t nPol, size_t nChannels, size_t nAntennae) const =0

## Protected Member Functions

| TimeBlockEncoder ()

## Detailed Description

Definition at line 34 of file timeblockencoder.h.

## Member Typedef Documentation

## DBuffer

typedef TimeBlockBuffer<std::complex<double> > TimeBlockEncoder::DBuffer

Definition at line 38 of file timeblockencoder.h.

## DBufferRow

typedef TimeBlockBuffer<std::complex<double>>::DataRow TimeBlockEncoder::DBufferRow

Definition at line 39 of file timeblockencoder.h.

## FBuffer

typedef TimeBlockBuffer<std::complex<float> > TimeBlockEncoder::FBuffer

Definition at line 36 of file timeblockencoder.h.

## FBufferRow

typedef TimeBlockBuffer<std::complex<float>>::DataRow TimeBlockEncoder::FBufferRow

Definition at line 37 of file timeblockencoder.h.

## symbol_t

typedef unsigned TimeBlockEncoder::symbol_t

Definition at line 41 of file timeblockencoder.h.

## Constructor & Destructor Documentation

## ~TimeBlockEncoder()

virtual TimeBlockEncoder::~TimeBlockEncoder | ( |  | ) |

inline virtual

Definition at line 43 of file timeblockencoder.h.

## TimeBlockEncoder()

TimeBlockEncoder::TimeBlockEncoder | ( |  | ) |

inline protected

Definition at line 72 of file timeblockencoder.h.

## Member Function Documentation

## Decode()

virtual void TimeBlockEncoder::Decode | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | FBuffer & | buffer,
|  | const symbol_t * | symbolBuffer,
|  | size_t | blockRow,
|  | size_t | antenna1,
|  | size_t | antenna2 )

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## EncodeWithDithering()

virtual void TimeBlockEncoder::EncodeWithDithering | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | FBuffer & | buffer,
|  | float * | metaBuffer,
|  | symbol_t * | symbolBuffer,
|  | size_t | antennaCount,
|  | std::mt19937 & | rnd )

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## EncodeWithoutDithering()

virtual void TimeBlockEncoder::EncodeWithoutDithering | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | FBuffer & | buffer,
|  | float * | metaBuffer,
|  | symbol_t * | symbolBuffer,
|  | size_t | antennaCount )

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## InitializeDecode()

virtual void TimeBlockEncoder::InitializeDecode | ( | const float * | metaBuffer,
|  | size_t | nRow,
|  | size_t | nAntennae )

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## MetaDataCount()

virtual size_t TimeBlockEncoder::MetaDataCount | ( | size_t | nRow,
|  | size_t | nPol,
|  | size_t | nChannels,
|  | size_t | nAntennae ) const

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## SymbolCount() [1/2]

virtual size_t TimeBlockEncoder::SymbolCount | ( | size_t | nRow | ) | const

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## SymbolCount() [2/2]

virtual size_t TimeBlockEncoder::SymbolCount | ( | size_t | nRow,
|  | size_t | nPol,
|  | size_t | nChannels ) const

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

## SymbolsPerRow()

virtual size_t TimeBlockEncoder::SymbolsPerRow | ( |  | ) | const

pure virtual

Implemented in AFTimeBlockEncoder, RFTimeBlockEncoder, and RowTimeBlockEncoder.

The documentation for this class was generated from the following file:

- tables/Dysco/timeblockencoder.h